import { Country } from '@/classes/Enum/Country'
import { Gender } from '@/classes/Enum/Gender'

export class FirstNameGenerator {
  plMaleFirstNames = [
    'Adamek',
    'Ada\u015b',
    'Aleksander',
    'Alfons',
    'Alojzy',
    'Ambro\u017cy',
    'Andrzej',
    'Antoni',
    'Arkadiusz',
    'Artur',
    'Baltazar',
    'Barnaba',
    'Bartek',
    'Bart\u0142omiej',
    'Bartosz',
    'Bernard',
    'Biernat',
    'Bogumi\u0142',
    'Bogurad',
    'Bogus\u0142aw',
    'Bogu\u015b',
    'Bolek',
    'Boles\u0142aw',
    'Bonawentura',
    'Bonifacy',
    'Borys',
    'Bronis\u0142aw',
    'Cezary',
    'Cyryl',
    'Czes\u0142aw',
    'Damian',
    'Daniel',
    'Dariusz',
    'Dawid',
    'Domarad',
    'Domaradz',
    'Dominik',
    'Dzier\u017cykraj',
    'Edward',
    'Emil',
    'Eryk',
    'Ezdrasz',
    'Fabian',
    'Filip',
    'Franciszek',
    'Gabriel',
    'Gniewosz',
    'Goc\u0142aw',
    'Gracjan',
    'Grzegorz',
    'Grzesiek',
    'Grze\u015b',
    'Gustaw',
    'Habakuk',
    'Henryk',
    'Hubert',
    'Igor',
    'Igorek',
    'Ildefons',
    'Ireneusz',
    'Iwan',
    'Izajasz',
    'Jacek',
    'Jakub',
    'Jan',
    'Janusz',
    'Jaros\u0142aw',
    'Jaru\u015b',
    'Jasiek',
    'Jerzy',
    'Jonatan',
    'J\xf3zef',
    'Judasz',
    'Juliusz',
    'Jurek',
    'Juru\u015b',
    'Justyn',
    'Kacper',
    'Kamil',
    'Karol',
    'Kazimierz',
    'Klaudiusz',
    'Kochan',
    'Konrad',
    'Krystian',
    'Krzysztof',
    'Krzy\u015b',
    'Ksawery',
    'Lasota',
    'Lech',
    'Les\u0142aw',
    'Leszek',
    'Lew',
    'Lucek',
    'Lucjan',
    'Lucjusz',
    'Ludwik',
    '\u0141ukasz',
    'Maciej',
    'Marcel',
    'Marcin',
    'Marek',
    'Marian',
    'Mariusz',
    'Mateusz',
    'Maurycy',
    'Micha\u0142',
    'Micha\u0142ek',
    'Micha\u015b',
    'Mieczys\u0142aw',
    'Mieszko',
    'Mietek',
    'Miko\u0142aj',
    'Mi\u0142osz',
    'Miros\u0142aw',
    'Nawoj',
    'Niemir',
    'Nierod',
    'Norbert',
    'Olaf',
    'Oleg',
    'Olek',
    'Olgierd',
    'Oliwer',
    'Oliwier',
    'Oskar',
    'Pawe\u0142',
    'Pawe\u0142ek',
    'Piotr',
    'Piotrek',
    'Piotru\u015b',
    'Poniat',
    'Przemys\u0142aw',
    'Racibor',
    'Rac\u0142aw',
    'Radek',
    'Rados\u0142aw',
    'Radzim',
    'Radzis\u0142aw',
    'Rafa\u0142',
    'Rec\u0142aw',
    'Remigiusz',
    'Robert',
    'Roman',
    'Romek',
    'Ryszard',
    'Ry\u015b',
    'Sambor',
    'Sebastian',
    'Sergiusz',
    'Seweryn',
    'S\u0142awomir',
    'Stanis\u0142aw',
    'Sta\u015b',
    'Stefan',
    'Sulejman',
    'Sulich',
    'Sylwester',
    'Szczepan',
    'Szcz\u0119sny',
    'Szymek',
    'Szymon',
    'Szymu\u015b',
    'Tadeusz',
    'Tomasz',
    'Tytus',
    'Ulryk',
    'Wac\u0142aw',
    'Waldek',
    'Waldemar',
    'Waleriusz',
    'Wawrzyniec',
    'Wies\u0142aw',
    'Wiktor',
    'Wincenty',
    'Wit',
    'Witek',
    'Witold',
    'Witos\u0142aw',
    'W\u0142adys\u0142aw',
    'W\u0142odek',
    'W\u0142odzimierz',
    'Wojciech',
    'Wojcik',
    'Wojs\u0142aw',
    'Wojtas',
    'Wojtasz',
    'Wojtek',
    'Wojtu\u015b',
    'Wszerad',
    'Zachariasz',
    'Zbigniew',
    'Zbylut',
    'Zbyszek',
    'Zdzis\u0142aw',
    'Zygmunt',
    'Zygu\u015b',
    '\u017begota'
  ]

  plFemaleFirstNames = [
    'Agata',
    'Agnieszka',
    'Agusia',
    'Aleksandra',
    'Alicja',
    'Amanda',
    'Anastazja',
    'Aneta',
    'Ania',
    'Anka',
    'Anna',
    'Apolonia',
    'Asia',
    'Barbara',
    'Basia',
    'Beata',
    'Benedykta',
    'Bernadeta',
    'Bogdana',
    'Bogumi\u0142a',
    'Boles\u0142awa',
    'Bo\u017cena',
    'Bo\u017cenka',
    'Bronis\u0142awa',
    'Brygida',
    'Cecylia',
    'Celestyna',
    'Czes\u0142awa',
    'Dagmara',
    'Danuta',
    'Dobros\u0142awa',
    'Dominika',
    'Dorota',
    'Dorotka',
    'Edwarda',
    'Edyta',
    'Ela',
    'Eleonora',
    'El\u017cbieta',
    'Emilia',
    'Emilka',
    'Ewa',
    'Ewelina',
    'Ewka',
    'Ewunia',
    'Franciszka',
    'Gabriela',
    'Genowefa',
    'Gosia',
    'Gra\u017cyna',
    'Halina',
    'Hania',
    'Hanna',
    'Helena',
    'Henryka',
    'Hildegarda',
    'Honorata',
    'Iga',
    'Irena',
    'Iwana',
    'Iwona',
    'Iwonka',
    'Izabela',
    'Jadwiga',
    'Jadzia',
    'Jagoda',
    'Janina',
    'Joanna',
    'Joasia',
    'Jolanta',
    'Judyta',
    'Julia',
    'Justyna',
    'Kamila',
    'Karolina',
    'Kasia',
    'Katarzyna',
    'Kazimiera',
    'Klara',
    'Klaudia',
    'Klotylda',
    'Krysia',
    'Krystyna',
    'Kunegunda',
    'Lena',
    '\u0141ucja',
    'Magda',
    'Magdalena',
    'Malina',
    'Ma\u0142gorzata',
    'Maria',
    'Marianna',
    'Mariola',
    'Mariolka',
    'Marta',
    'Martyna',
    'Marycha',
    'Maryla',
    'Marylka',
    'Marysia',
    'Marzena',
    'Matylda',
    'Melania',
    'Michalina',
    'Monika',
    'Nadia',
    'Natalia',
    'Oliwia',
    'Patrycja',
    'Paulina',
    'Renata',
    'R\xf3\u017ca',
    'Stanis\u0142awa',
    'Stefania',
    'Sylwia',
    'Szarlota',
    'Teresa',
    'Urszula',
    'Wanda',
    'Weronika',
    'Wies\u0142awa',
    'Wiktoria',
    'Wioleta',
    'Zofia',
    'Zuzanna',
    '\u017baneta'
  ]

  ltMaleFirstNames = [
    'Adolfas',
    'Aivaras',
    'Albinas',
    'Aleksandras',
    'Alfonsas',
    'Alfredas',
    'Algimantas',
    'Algirdas ',
    'Algis',
    'Alvydas',
    'Andrius',
    'Antanas',
    'Antons',
    'Arnoldas',
    'Arturas',
    'Arunas',
    'Arvydas',
    'Audrius',
    'Aurelijus',
    'Aurimas',
    'Balys',
    'Benas',
    'Benjaminas',
    'Bernardas',
    'Bronislovas',
    'Bronius',
    'Ceslovas',
    'Dainius',
    'Danas',
    'Darius',
    'Daumantas',
    'Deimantas',
    'Deividas',
    'Domantas',
    'Donatas',
    'Edgaras',
    'Edmundas',
    'Eduardas',
    'Edvardas',
    'Edvinas',
    'Egidijus',
    'Eimantas',
    'Ernestas',
    'Eugenijus',
    'Evaldas',
    'Feliksas',
    'Gediminas',
    'Giedrius',
    'Gintaras',
    'Gintautas',
    'Henrikas',
    'Ignas',
    'Isakas',
    'Jeronimas',
    'Jokubas',
    'Jonas',
    'Juozapas',
    'Juozas',
    'Jurgis',
    'Justas',
    'Justinas',
    'Karolis',
    'Kazimieras',
    'Kazys',
    'Kestutis',
    'Laurynas',
    'Leonardas',
    'Leonas',
    'Linas',
    'Lionginas',
    'Liudvikas',
    'Lukas',
    'Mantas',
    'Marijonas',
    'Marius ',
    'Markas',
    'Martynas',
    'Mikalojus',
    'Mindaugas ',
    'Modestas',
    'Mykolas',
    'Nerijus',
    'Osvaldas',
    'Ovidijus',
    'Paulius',
    'Petras',
    'Povilas',
    'Pranas',
    'Raimundas',
    'Ramunas',
    'Remigijus',
    'Ricardas',
    'Rimantas',
    'Rimas',
    'Rimvydas',
    'Robertas',
    'Rolandas',
    'Romanas',
    'Romualdas',
    'Rytis',
    'Sarunas',
    'Saulius',
    'Sigitas',
    'Silvestras',
    'Simas',
    'Simonas',
    'Stasys',
    'Steponas',
    'Svajunas',
    'Tadas ',
    'Tauras',
    'Tautvilas',
    'Teodoras',
    'Tomas',
    'Urbonas',
    'Vaidas',
    'Vaidotas ',
    'Valdas',
    'Valdemaras',
    'Vidmantas',
    'Viktoras',
    'Vincas',
    'Virgilijus',
    'Virginijus',
    'Vladas',
    'Vygantas',
    'Vytautas',
    'Vytenis ',
    'Zenonas',
    'Zigmas',
    'Zydrunas',
    'Zygimantas'
  ]

  ltFemaleFirstNames = ['Agne',
    'Akvile',
    'Aldona',
    'Aukse',
    'Ausra',
    'Ausrine',
    'Austeja',
    'Austra',
    'Biruta',
    'Brigita',
    'Daina',
    'Dalia',
    'Danguole',
    'Danute',
    'Deimante',
    'Diana',
    'Edita',
    'Egle',
    'Elena',
    'Eugenija',
    'Gabija',
    'Gabriele',
    'Genovaite',
    'Gintare',
    'Grazina',
    'Ieva',
    'Indre',
    'Inga',
    'Ingrida',
    'Irena',
    'Irene',
    'Irina',
    'Jolanta',
    'Jurate',
    'Jurga',
    'Justina',
    'Kristina',
    'Laima',
    'Laura',
    'Lilija',
    'Lina',
    'Loreta',
    'Magdalena',
    'Marija',
    'Milda',
    'Monika',
    'Nijole',
    'Olga',
    'Ona',
    'Paulina',
    'Raminta',
    'Ramune',
    'Rasa',
    'Ruta',
    'Salomeja',
    'Sigita',
    'Silvija',
    'Sofija',
    'Sonata',
    'Ugne',
    'Urte',
    'Vaida',
    'Vaiva',
    'Vanda',
    'Veronica',
    'Viktorija',
    'Vilija',
    'Vilma',
    'Violeta',
    'Virginija',
    'Vitalija',
    'Zita',
    'Zivile'
  ]

  eeMaleFirstNames = ['Aadu',
    'Aarne',
    'Ado',
    'Ago',
    'Ain',
    'Aivar',
    'Aksel',
    'Alar',
    'Albert',
    'Allar',
    'Alo',
    'Andreas',
    'Andres',
    'Andrus',
    'Anti',
    'Anto',
    'Anton',
    'Ants',
    'Ardo',
    'Argo',
    'Arno',
    'Arnold',
    'Artur',
    'Arvi',
    'Arvo',
    'Asko',
    'August',
    'Avo',
    'Eduard',
    'Eerik',
    'Eero',
    'Egon',
    'Eiko',
    'Einar',
    'Eino',
    'Elmar',
    'Elmo',
    'Emil',
    'Endel',
    'Enn',
    'Erki',
    'Erkki',
    'Erni',
    'Ervin',
    'Evald',
    'Georg',
    'Gert',
    'Gunnar',
    'Gustav',
    'Hannes',
    'Harald',
    'Harri',
    'Heiki',
    'Heino',
    'Hendrik',
    'Henrik',
    'Hillar',
    'Illimar',
    'Ilmar',
    'Imre',
    'Indrek',
    'Ingmar',
    'Innar',
    'Ivar',
    'Ivo',
    'Jaagup',
    'Jaak',
    'Jaan',
    'Jaanus',
    'Jan',
    'Janar',
    'Johannes',
    'Joonas',
    'Joosep',
    'Juhan',
    'Juho',
    'J\xfcrgen',
    'J\xfcri',
    'Kaarel',
    'Kaido',
    'Kalev',
    'Kaljo',
    'Kalju',
    'Kalle',
    'Kalmer',
    'Kaspar',
    'Kasper',
    'Kert',
    'Koit',
    'Kristjan',
    'Kristo',
    'Lauri',
    'Laurits',
    'Leho',
    'Lembit',
    'Lennart',
    'Madis',
    'Magnus',
    'Mait',
    'Marek',
    'Margus',
    'Marko',
    'M\xe4rt',
    'Mart',
    'Martin',
    'Mati',
    'Mattias',
    'Meelis',
    'Mihkel',
    'Mikk',
    'Neeme',
    'Niilo',
    'Olari',
    'Olev',
    'Oscar',
    'Osvald',
    'Ott',
    'Paavo',
    'Paul',
    'Peep',
    'Peeter',
    'Priidu',
    'Priit',
    'Ragnar',
    'Raimo',
    'Rain',
    'Rainer',
    'Rait',
    'Raivo',
    'Rasmus',
    'Raul',
    'Rauno',
    'Rein',
    'Riho',
    'Risto',
    'Robert',
    'Roland',
    'Sander',
    'Siim',
    'Silver',
    'Sten',
    'Sulev',
    'Sven',
    'Taavi',
    'Tanel',
    'Tarmo',
    'Tauno',
    'Teet',
    'Tiit',
    'Timo',
    'Toivo',
    'T\xf5nis',
    'T\xf5nu',
    'Toomas',
    'Uku',
    '\xdclar',
    '\xdcllar',
    '\xdclo',
    'Ulrik',
    'Uno',
    'Urmas',
    'Uuno',
    'Vahur',
    'Vaino',
    'Valdo',
    'Vallo',
    'Valter',
    'Veiko',
    'Vello',
    'Viljar',
    'Viljo',
    'Villem',
    'Villu',
    'Voldemar'
  ]

  eeFemaleFirstNames = [
    'Agnes',
    'Aili',
    'Aino',
    'Airi',
    'Alma',
    'Anna',
    'Anne',
    'Anneli',
    'Anni',
    'Annika',
    'Anu',
    'Asta',
    'Astrid',
    'Birgit',
    'Dagmar',
    'Eeva',
    'Elina',
    'Ellen',
    'Elli',
    'Elsa',
    'Ene',
    'Epp',
    'Erika',
    'Erna',
    'Ester',
    'Eva',
    'Eve',
    'Evelin',
    'Evi',
    'Gerli',
    'Getter',
    'Grete',
    'Heidi',
    'Hele',
    'Helene',
    'Helge',
    'Heli',
    'Helmi',
    'Herta',
    'Hilda',
    'Hilja',
    'Ida',
    'Iiris',
    'Ilse',
    'Imbi',
    'Ines',
    'Inge',
    'Ingrid',
    'Ita',
    'Jaana',
    'Johanna',
    'Kadri',
    'Kaia',
    'Kaija',
    'Kaili',
    'Kaire',
    'Kaisa',
    'Kaja',
    'Karin',
    'Karoliina',
    'Katariina',
    'K\xe4tlin',
    'Katrin',
    'Kersti',
    'Ketlin',
    'Kirsti',
    'Klaudia',
    'Koidu',
    'Krista',
    'Kristel',
    'Kristiina',
    'Kulli',
    'Laine',
    'Laura',
    'Lenna',
    'Liina',
    'Liis',
    'Liisa',
    'Liisi',
    'Lilli',
    'Linda',
    'Lotte',
    'Maarja',
    'Maia',
    'Mare',
    'Maret',
    'Margit',
    'Mari',
    'Maria',
    'Meeli',
    'Merike',
    'Merle',
    'Meta',
    'Miina',
    'Minna',
    'Mirjam',
    'Monika',
    'Piia',
    'Piret',
    'Raine',
    'Riin',
    'Riina',
    'Rita',
    'Saara',
    'Salme',
    'Selma',
    'Signe',
    'Silvia',
    'Sirje',
    'Terje',
    'Tiina',
    'Tiiu',
    'Triin',
    'Tuuli',
    '\xdclle',
    'Ulvi',
    'Urve',
    'Valve',
    'Vilma',
    'Virve'
  ]

  generate (country: Country, gender: Gender) {
    switch (country) {
      case Country.POLAND:
        return Gender.MALE === gender
          ? this.plMaleFirstNames[Math.floor(Math.random() * this.plMaleFirstNames.length)]
          : this.plFemaleFirstNames[Math.floor(Math.random() * this.plFemaleFirstNames.length)]
      case Country.LITHUANIA:
        return Gender.MALE === gender
          ? this.ltMaleFirstNames[Math.floor(Math.random() * this.ltMaleFirstNames.length)]
          : this.ltFemaleFirstNames[Math.floor(Math.random() * this.ltFemaleFirstNames.length)]
      default:
        return Gender.MALE === gender
          ? this.eeMaleFirstNames[Math.floor(Math.random() * this.eeMaleFirstNames.length)]
          : this.eeFemaleFirstNames[Math.floor(Math.random() * this.eeFemaleFirstNames.length)]
    }
  }
}

export default new FirstNameGenerator()
